Subject: Re: [PATCH 2/3] net: netfilter: Add RFC-7597 Section 5.1 PSID support

From: Florian Westphal <[email-masked]>
Date: Thu, 22 Jul 2021 09:17:50 +0200

Cole Dishington <[email-masked]> wrote:
> Adds support for masquerading into a smaller subset of ports -
> defined by the PSID values from RFC-7597 Section 5.1. This is part of
> the support for MAP-E and Lightweight 4over6, which allows multiple
> devices to share an IPv4 address by splitting the L4 port / id into
> ranges.
> 
> Co-developed-by: Anthony Lineham <[email-masked]>
> Signed-off-by: Anthony Lineham <[email-masked]>
> Co-developed-by: Scott Parlane <[email-masked]>
> Signed-off-by: Scott Parlane <[email-masked]>
> Signed-off-by: Blair Steven <[email-masked]>
> Signed-off-by: Cole Dishington <[email-masked]>
> ---
> +
> +	/* In this case we are in PSID mode, avoid checking all ranges by computing bitmasks */
> +	if (is_psid) {
> +		u16 power_j = ntohs(max->all) - ntohs(min->all) + 1;

I think this needs to be 'u32 power_j' to prevent overflow of
65535 + 1 -> 0.

> +		if (base)
> +			off = prandom_u32() % (((1 << 16) / base) - 1);

I think this can use prandom_u32_max(((1 << 16) / base) - 1).

I have no other comments.  Other kernel patches LGTM.